Waiting for engine...
Skip to main content

Agent Control Tower GraphQL APIs

Currently, the Custom account APIs alone are available as public APIs.

Custom accounts list accounts and agents from providers not currently supported by the Agent Control Tower like the Amazon Bedrock Provider. Custom accounts helps list all your custom agents in one place. You can create multiple accounts representing different services and add, organize, and group agents. They act as an overarching container to manually register and list agents from providers that are currently not supported by Boomi.

The Custom Accounts GraphQL APIs expose many GraphQL queries and mutations to retrieve, create, and update data.

Benefits of Custom Accounts API include:

  • Broader ecosystem support: Seamlessly integrate and manage third-party or custom AI providers not natively supported in ACT.
  • Unified catalog: Centralize all providers, agents, and their relationships with tasks, tools, instructions, and associated models in ACT.
  • Faster onboarding: Eliminate the need for backend enablement. You can directly onboard new providers and agents via APIs.
  • Consistency across UI and API: Providers and agents created via APIs are automatically reflected in the ACT interface for unified visibility.
  • Scalability: Support rapid expansion of the AI ecosystem as new providers emerge, without waiting for native integrations.
  • Auditable: Every creation, update, and deletion is logged for full traceability and governance.

Authentication

  • Your Boomi platform account should have the AI_AGENT_REGISTRY feature enabled.

  • All GraphQL requests require a valid JWT (JSON Web Token) for both authentication and authorization.

    Step 1: Generate a JWT

    Send a GET request to the following endpoint using Basic Authentication. This request returns a JWT in the response:

    US: https://api.boomi.com/auth/jwt/generate/{accountID}

    GB: https://api.platform.gb.boomi.com/auth/jwt/generate/{accountID}

    Username: BOOMI_TOKEN.username
    Password: <Boomi_Platform_ApiToken>

    To learn how to create a new API token, refer to Adding new API Tokens on a User Account.

    Step 2: Use the JWT for GraphQL API Requests

    Include the JWT in the Authorization header for all GraphQL requests to:

    • US: https://platform.boomi.com/graphql
    • GB: https://api.platform.gb.boomi.com/graphql

    Header format: Authorization: Bearer <JWT>

    note

    JWTs expire every five minutes. You must generate a new token once it expires.

Rate limits

The GraphQL APIs include rate limits to guard against large spikes of incoming requests and to improve share access equally across all incoming requests. Rate limiting is applied to the number of your requests running on each platform instance. Your requests can all go to the same runtime instance or distributed across instances.

If you send a large number of requests in succession, you might get a status code 429 as your error response to the request. This status code means that you sent too many requests. Allow your requests to clear out before you resubmit the requests.

Supported categories

OperationQUERYMUTATION
Provider Account✅ Supported✅ Supported
AI Agent✅ Supported✅ Supported
Agent Alias✅ Supported✅ Supported
Large language model✅ Supported✅ Supported
Task✅ Supported✅ Supported
Tools✅ Supported✅ Supported
Guardrails✅ Supported✅ Supported

To learn more about available queries and mutations, refer to Operations. For object details, refer to Types.

Custom Accounts Error Codes

The possible error codes you are likely to encounter:

Error codes
Error CodeError Message
INVALID_CREDENTIALS_INPUTThe credentials provided are either empty, invalid, or incorrectly formatted.
INVALID_CREDENTIALS_KEYThe provided credentials are invalid, preventing successful authentication with the agent provider.
PROVIDER_CONNECTION_FAILEDUnable to establish a connection to the Agent Provider. Please check the connection details and ensure the provider is reachable.
INVALID_INPUTThe provided input contains invalid character or whitespace. Please ensure all inputs are correct and properly formatted.
AUTHENTICATED_ACCOUNT_ID_MISSINGUnable to obtain authenticated account ID.
PAGE_INDEX_INVALIDThe provided page index is invalid. The page number must be 0 or greater. Please ensure the page number is valid.
PAGE_SIZE_INVALIDThe provided page size is invalid. The page size must be greater than 0. Please ensure the page size is valid.
FETCH_AI_PROVIDER_ACCOUNT_ACCOUNT_ERRORUnable to retrieve AI Agent Provider Account Details.
INVALID_PROVIDER_ACCOUNT_IDThe provided provider account id {0} is not in valid UUID format.
INVALID_AGENT_UUIDThe provided agent id {0} is not in valid UUID format.
INVALID_AGENT_ALIAS_UUIDThe provided agent alias id {0} is not in valid UUID format.
INVALID_SESSION_IDThe provided session id {0} is empty.
INVALID_SESSION_ID_LISTThe provided session id list is empty.
INVALID_AGENT_VERSION_EXTERNAL_IDThe provided agent version external id {0} is empty.
TOOL_ALREADY_EXISTSTool with the provided externalId already exists for the supplied provider account ID.
FETCH_AI_AGENT_TAG_ERRORUnable to retrieve AI Agent Tag Details.
INVALID_TOOL_IDThe provided tool id is not in valid UUID format.
INVALID_TASK_IDThe provided task id is not in valid UUID format.
TOOL_NOT_FOUNDTool with the provided ID 0 could not be located.
MISSING_TOOL_ID_OR_EXTERNAL_IDPlease ensure you provide either the Tool ID or the Tool External ID.
STALE_UPDATEUpdate rejected: The provided update at provider's timestamp is not newer.
PROVIDER_ACCOUNT_NOT_FOUNDProvider account not found with the supplied ID 0.
FETCH_AI_AGENT_PROVIDER_ERRORUnable to retrieve AI Agent provider details.
ACCOUNT_NOT_FOUNDThe AI agent provider account corresponding to the supplied ID 0 could not be located.
ACCOUNT_NAME_EMPTYThe supplied provider account name is either empty or null.
INVALID_CREDENTIALSThe provided credentials are either empty or invalid.
INVALID_AUTH_SCHEMAThe provided authentication schema is either empty or not of type AiProviderAuthSchema.
INVALID_METADATA_JSONThe supplied metadata JSON is either empty or invalid.
REGION_REQUIRED_IF_AUTHThe 'region' field is required when the 'authSchema' is set to 0.
UNSUPPORTED_REGIONThe provider region 0 is not supported.
CROSS_ACCOUNT_MONITORING_CONFIG_FAILEDUnable to update cross-account monitoring configuration in region 0.
EXTERNAL_ID_NOT_FOUNDThe External ID required for cross-account monitoring setup could not be found.
PRESIGNED_URL_GENERATION_FAILEDFailed to generate presigned URL for the CloudFormation template.
INVALID_PROVIDER_ACCOUNT_STATUSThe provider account status provided is invalid.
SSM_UPDATE_FAILEDThe SSM update has failed.
INVALID_EXTERNAL_PROVIDER_ACCOUNT_IDThe supplied external provider account ID is either null or empty.
INVALID_CONNECTION_DETAILSThe health check connection failed due to the provided credentials for the authentication schema.
DIFFERENT_EXTERNAL_PROVIDER_ACCOUNT_IDThe error indicates that the credentials supplied correspond to an external provider account ID that differs from the one linked to the account currently being updated in the Registry. The external provider account ID linked to the account is 0.
ACCOUNT_EXISTS_FOR_PROVIDER_ACCOUNT_ID_AND_TYPEAn AI agent registry account already exists for the specified provider account ID 0 and provider type 1.
SYNC_AI_AGENT_TAG_ERRORError syncing tags.
SYNC_PROVIDER_ACCOUNT_ERRORError while syncing Provider Account 0.
FETCH_AI_AGENT_ERRORUnable to retrieve AI Agents Details.
AI_AGENT_NOT_FOUNDAI Agent not found.
AI_AGENT_VERSION_NOT_FOUNDThe specified AI Agent version ID does not correspond to any existing AI Agent version in the registry. Please verify that the ID is correct and that the agent version exists.
AI_AGENT_TASK_NOT_FOUNDThe specified AI Agent task ID does not correspond to any existing AI Agent task in the registry. Please verify that the ID is correct and that the agent task exists.
AI_AGENT_TASK_NAME_ALREADY_EXISTAI agent task name already exists. Please use a unique name.
CREATE_AI_AGENT_TASK_ERRORUnexpected error occurred while creating Task for provider account 0. Error: 1.
AI_AGENT_TASK_NAME_REQUIREDAI agent task name is required. Please provide a valid name for the AI agent task.
AI_AGENT_TASK_UPDATE_ERRORUnexpected error occurred while updating AI Agent Task. Error: 0.
AI_AGENT_ALIAS_NOT_FOUNDThe specified AI Agent alias ID does not correspond to any existing AI Agent alias in the registry. Please verify that the ID is correct and that the agent alias exists.
AI_AGENT_CREATE_ERRORError while creating AI Agent.
AI_AGENT_UPDATE_ERRORError while updating AI Agent.
AI_AGENT_VERSION_ALREADY_EXISTSAgent and version already exist. Please try updating.
AI_AGENT_VERSION_TAG_ERRORError fetching tags for agent version with ID 0.
AI_AGENT_AUTH_CHECK_ERRORThe logged-in account ID is not allowed to access this agent.
INVALID_TRUST_LEVELThe provided trust level is either null or not of type AiAgentRegistryTrustLevel.
FAILED_TO_ADD_TRUST_LEVELFailed to add trust level for the provided agent version 0.
INVALID_TAG_INPUTThe provided tags input is either null or empty, or one of the tag key is also null or empty.
AI_AGENT_BY_VERSION_ERRORError while fetching AI Agent by version ID 0.
AI_AGENT_BY_ALIAS_ERRORError while fetching AI Agent by alias ID 0.
PROVIDER_ACCOUNT_DUPLICATE_CONSTRAINTAn agent provider account with the specified credentials already exists with idp account id 0.
PROVIDER_ACCOUNT_DUPLICATE_NAME_CONSTRAINTThe account provider name already exists in the registry. Please choose a different name.
BEDROCK_ACCOUNT_REGION_IS_CHANGEDThe region field cannot be modified after the AWS Bedrock provider account has been established.
GARDEN_ACCOUNT_ID_IS_CHANGEDThe account ID field cannot be modified after the Boomi Agent Garden provider account has been established.
FAILED_TO_ENABLE_AGENT_VERSIONUnable to enable the specified agent version: 0. Please check the version number and try again.
FAILED_TO_DISABLE_AGENT_VERSIONUnable to disable the specified agent version: 0. Please check the version number and try again.
FAILED_TO_ENABLE_AGENT_ALIASUnable to enable the specified agent alias: 0. Please check the alias number and try again.
FAILED_TO_DISABLE_AGENT_ALIASUnable to disable the specified agent alias: 0. Please check the alias number and try again.
FAILED_TO_DELETE_PROVIDER_ACCOUNTUnable to delete the specified agent provider account: 0. Please check the provider account ID and try again.
FAILED_TO_DELETE_OAM_LINKUnable to remove the OAM link in the customer's AWS account for the monitoring account 0 and the agent provider account: 1.
ACCOUNT_NAME_TOO_LONGThe provided provider account name {0} exceeds the maximum limit of 200 characters. Please shorten it to comply with this requirement.
INVALID_CONNECTION_DETAILS_FOR_AWS_BEDROCKConnection validation failed: Invalid credentials or region specified for AWS Bedrock.
PROVIDER_ACCOUNT_SYNC_IN_PROGRESSA synchronization process is currently in progress. Please wait for it to complete or for 0 minutes (whichever comes first) before attempting to try again.
PROVIDER_ACCOUNT_STATUS_ALREADY_SETThe provider account status is already set to 0. Please refresh the page!
AGENT_ALREADY_ENABLEDThe agent is already enabled. Please refresh the page!
AGENT_ALREADY_DISABLEDThe agent is already disabled. Please refresh the page!
INVALID_PROVIDER_TYPEThe specified agent provider account type is either missing or not of the type AiAgentProviderType.
FETCH_AI_AGENT_FILTER_ERRORUnable to retrieve AI Agent filter Details.
PROVIDER_ACCOUNT_DESCRIPTION_TOO_LONGThe specified agent provider account description 0 exceeds the maximum limit of 1000 characters. Please reduce the length to meet this requirement.
INVALID_LLM_INPUTThe provided LLM input is either null or empty.
AI_AGENT_CREATE_INPUT_NULLThe input provided for AI agent creation is either null or empty. Please provide valid input parameters.
AI_AGENT_NAME_REQUIREDAI agent name is required. Please provide a valid name for the AI agent.
AI_AGENT_NAME_ALREADY_EXISTAI agent name already exists. Please use a unique name.
VERSION_ID_REQUIREDAi agent version id is required, Please provide a valid version id for the Agent.
NON_CUSTOM_PROVIDER_AGENTThis operation is allowed only for custom provider type. Other provider types are not supported.
EXTERNAL_ACCOUNT_ID_REQUIREDAccount ID of the system that has the AI agents is required.
INVALID_AWS_ACCOUNT_IDThe provided AWS account ID 0 is invalid. It must be a 12-digit number.
FETCH_AI_AGENT_REFRESH_TRACKER_ERRORError while fetching AI Agent Refresh Tracker Status.
FETCH_AI_AGENT_LLMS_ERRORError while fetching AI Agent LLMs for Account: 0.
PROVIDER_ACCOUNT_ID_NOT_FOUNDOne or more specified Provider Account IDs not found.
AGENT_ID_NOT_FOUNDOne or more Agent IDs were not found or do not belong to the specified provider account.
AGENT_ALIAS_ID_NOT_FOUNDOne or more specified Agent Alias IDs not found.
NO_PROVIDER_ACCOUNTS_FOUNDYour account does not have any provider accounts.
PROVIDER_ACCOUNT_SYNC_DISABLEDAgent sync failed. Syncing has been deactivated for the supplied provider account ID 0.
LICENSE_NOT_FOUND_ERRORLicense Not Found for provided Tier Id.
UPDATE_LICENSE_LIMIT_ERRORError in updating license limit.
UPDATE_IDP_ACCOUNT_TIER_LIMIT_ERRORError in updating IdP Account Tier license limit.
UNABLE_TO_FIND_LICENSE_ASSOCIATION_ERRORUnable to find the License Association for provided account.
INVALID_OFFSETInvalid pagination offset value. Value must be greater than or equal to 0.
INVALID_LIMITInvalid pagination limit value. Value must be greater than 0.
OAM_LINK_ALREADY_PRESENT_ERROROam Link is already present from your AWS account to the provider account.
OAM_LINK_CREATION_FAILED_ERROROam Link creation failed.
INVALID_URLThe provided URL is invalid or missing. Please enter a valid URL and try again.
UNSUPPORTED_AUTH_SCHEMAInvalid authentication schema 0 for provider 1.
INVALID_CREDENTIALS_JSONThe supplied credentials JSON is either empty or invalid.
INVALID_AGENT_VERSION_IDSThe provided agent version IDs are either empty or null. Please supply a valid list of version IDs.
NO_LLM_INPUT_PROVIDED_TO_CREATENo LLM input has been provided for creating the LLM.
CREATE_AI_AGENT_LLM_ERRORUnexpected error occurred while creating LLM for provider account 0. Error: 1.
LLM_ALREADY_EXISTSLLM with the 0 1 already exists for provider account 2. Please use the update mutation to update the LLM.
UPDATE_AI_AGENT_LLM_ERRORUnexpected error occurred while updating LLM for id 0. Error: 1.
LLM_NOT_FOUNDLLM not found for provided id 0.
INVALID_LLM_EXTERNAL_IDThe provided LLM external id either empty or null.
LLM_EXTERNAL_ID_ALREADY_EXISTSThe provided LLM external id 0 already exist for current version of provider account id 1.
INVALID_LLM_NAMEThe provided llm name either empty or null.
INVALID_AI_AGENT_LLM_IDThe provided llm ID 0 is not in valid UUID format.
INVALID_JSONThe provided JSON input is either empty or invalid for the field: 0.
NO_ANOMALIES_FOUNDNo agent anomalies found.
FAILED_TO_FETCH_ANOMALIESFailed to fetch agent anomalies for Provider Account ID: 0.
FAILED_TO_FETCH_MULTIPLIERFailed to fetch multiplier information for Agent ID: 0 and Provider Account ID: 1.
INVALID_MULTIPLIER_VALUEInvalid multiplier value provided. Valid multiplier range is: 0 to 1.
FAILED_OVERRIDE_MULTIPLIERFailed to override multiplier value for Agent ID: 0 and Anomaly Metric Type: 1.
TOOL_MULTIPLE_ASSOCIATIONS_REQUIRE_DISASSOCIATIONTool is associated with 0 entities. Please specify which associations to remove using entityDisassociations parameter.
INVALID_ENTITY_TYPEInvalid entity type 0. Only 1 entity type(s) are allowed.
DESCRIPTION_TOO_LONGThe 0 description exceeds the maximum limit of 2000 characters. Please reduce the length to meet this requirement.
DELETE_AI_AGENT_LLM_ERRORUnexpected error occurred while deleting LLM for id 0.
DELETE_AI_AGENT_LLM_VERSION_ASSOCIATIONS_NOT_FOUND_ERRORLLM '0' is not associated with the specified agent IDs DRAFT versions.
LLM_INVALID_AGENT_VERSION_IDSOne or more invalid agent version ids provided, please provide valid Agent Version Ids.
FIELD_TOO_LONGThe provided 0 exceeds the maximum limit of 1 characters. Current length: 2. Please reduce the length to meet this requirement.
INVALID_FIELD_VALUEThe provided 0 cannot be null, empty, or contain only whitespace characters.
DUPLICATE_EXTERNAL_IDThe tool resource external ID is already in use. Please provide a unique external ID.
INVALID_AI_AGENT_TOOL_IDSThe provided agent tool IDs are either empty, null or invalid. Please provide valid Agent Tools IDs.
AI_AGENT_GUARDRAIL_ALREADY_EXISTSGuardrail with the provided name already exists for the supplied provider account ID.
AI_AGENT_GUARDRAIL_NOT_FOUNDThe specified AI Agent Guardrail ID does not correspond to any existing provider account in the registry.
CREATE_AI_AGENT_GUARDRAIL_ERRORUnexpected error occurred while creating Guardrail for provider account 0. Error: 1.
AI_AGENT_GUARDRAIL_NAME_REQUIREDAI agent Guardrail name is required. Please provide a valid name for the AI agent task.
AI_AGENT_GUARDRAIL_UPDATE_ERRORUnable to update AI Agent Guardrail. 0.
AGENT_ID_REQUIREDAt least one agent ID is required. Please provide valid agent IDs.
INVALID_AI_AGENT_GUARDRAIL_IDThe provided guardrail ID is not in valid UUID format.
AI_AGENT_GUARDRAIL_VERSION_ASSOCIATIONS_NOT_FOUNDGuardrail ID 0 is not associated with the specified agent version IDs.
AI_AGENT_GUARDRAIL_DELETE_ERRORError during guardrail deletion for guardrail ID 0.
AI_AGENT_TASK_DELETE_ERROR_DUE_TO_ASSOCIATIONSTask cannot be deleted since it has associations. Delete associations before deleting the task.
AI_AGENT_TOOL_DELETE_ERROR_DUE_TO_ASSOCIATIONSTool cannot be deleted since it has associations. Delete associations before deleting the task.
AI_AGENT_GUARDRAIL_DELETE_ERROR_DUE_TO_ASSOCIATIONSGuardrail cannot be deleted since it has associations. Delete associations before deleting the task.
AI_AGENT_LLM_DELETE_ERROR_DUE_TO_ASSOCIATIONSLLM cannot be deleted since it has associations. Delete associations before deleting the task.
AGENT_VERSION_ALREADY_EXISTSAgent version with name 0 and version 1 already exists for agent 2.
AGENT_ALREADY_EXISTS_FOR_EXTERNAL_IDAgent with name 0 and externalId 1 already exists for agent 2.
INVALID_AGENT_IDInvalid Agent ID provided: 0, please provide valid Agent ID.
INVALID_AGENT_VERSIONProvided version is invalid, please provide valid version.
VERSION_EDIT_NOT_ALLOWEDVersion can only be edited when status is draft.
INVALID_RELATED_ENTITY_IDProvided entity id:0 does not belong to the same provider account as the 1.
AI_AGENT_TOOL_ALREADY_EXISTSTool with the provided name already exists for the supplied provider account ID.
PROVIDER_ACCOUNT_MISMATCHProvided id does not belong to the same provider account.
AI_AGENT_TASK_VERSION_ASSOCIATIONS_NOT_FOUNDTask ID 0 is not associated with the specified agent version IDs.
CORTEX_INVALID_METADATA_JSONAt least one database configuration is required in metadataJson.
AI_AGENT_ALIAS_ALREADY_EXISTSAI agent alias with the provided name and ExternalId already exists for the supplied agent version ID.
AI_AGENT_ALIAS_NAME_ALREADY_EXISTSAn alias with name 0 already exists for the supplied agent version ID.
AI_AGENT_ALIAS_RESERVED_NAMEThe alias name 0 is reserved and cannot be used. Please choose a different name.
CREATE_AI_AGENT_ALIAS_ERRORUnexpected error occurred while creating AI Agent Alias for agent version 0. Error: 1.
LLM_NOT_DRAFTThe provided LLM is not a DRAFT version. Only DRAFT LLMs can be updated or deleted.
LLM_INVALID_AGENT_IDSOne or more invalid agent ids provided, please provide valid Agent Ids.
NON_DRAFT_TASK_NOT_EDITABLECan not perform any action on non DRAFT task 0.
NON_DRAFT_TOOL_NOT_EDITABLECan not perform any action on non DRAFT tool 0.
INVALID_AI_AGENT_TASK_IDSOne or more of the provided task IDs are either not in DRAFT status or do not belong to the same provider account.
Note

The 0, 1, etc. placeholders in the error messages are replaced with actual values at runtime using Java's MessageFormat.

On this Page